#!/usr/bin/env python3.5
# Copyright 2017 Digital
#
# This file is part of DigiLib.
#
# DigiLib is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# DigiLib is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DigiLib.  If not, see <http://www.gnu.org/licenses/>.

# Python modules
import atexit
import logging
import threading
import traceback
# Third party modules
import curio
import digilib.network
import digilib.misc

import .errmsg
log = logging.getLogger(__name__+"")
lgpio = logging.getLogger(__name__+".gpio")

# Error messages
# ERROR_TAKES_ARGUMENTS = "{} takes {} {} argument(s): {}"
# respond(ERROR_TAKES_ARGUMENTS.format(
#         command, "one", "positional", "<name>"))


class PinBase(object):
    """
    PinBase is the base class for all classes representing a gpio pin

    Parameters
    ----------
    pin_number: int
        number of the pin
    mode: gpio.OUT or gpio.IN
        ``gpio.IN`` if the pin is an read pin or ``gpio.OUT`` if the pin is an write pin
    """
    pin_number = None
    def __init__(self,pin_number,mode):
        super(PinBase,self).__init__()
        self.pin_number = pin_number
        _gpio.setup(self.pin_number,_gpio.OUT)

    def write(self,value):
        [value] = digilib.misc.parse_to_int_list(value)
        _gpio.write(self.pin_number,value)

    def read(self):
        value = _gpio.read(self.pin_number,value)
        return value

class DigitalPin(PinBase):
    def __init__(self,pin_number,mode):
        super(DigitalPin,self).__init__(pin_number,mode)

class AnalogPin(PinBase):
    def __init__(self,pin_number):
        super(AnalogPin,self).__init__(pin_number)


if __name__ == "__main__":
    pass






























#
